"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.array.concat.js");

var _error = require("../../error");

var _Symbol = require("../constants/Symbol");

var _evaluateVariableString = _interopRequireDefault(require("./evaluateVariableString"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var expectedBadVariableEvaluation = function expectedBadVariableEvaluation(variable, evalError) {
  return (0, _error.expected)({
    causes: [evalError],
    code: 'BadVariableEvaluation',
    data: {
      error: evalError,
      variable: variable
    },
    message: "An error occurred while evaluating the variable '".concat(variable.variableString, "'.\n\n\"").concat(evalError.message, "\"\n\n")
  });
};

var newVariable = function newVariable(variableString) {
  var _variable;

  var variable = (_variable = {}, _defineProperty(_variable, _Symbol.VARIABLE, true), _defineProperty(_variable, "evaluate", function evaluate(data, context) {
    try {
      return (0, _evaluateVariableString.default)(variableString, data, context);
    } catch (error) {
      throw expectedBadVariableEvaluation(variable, error);
    }
  }), _defineProperty(_variable, "variableString", variableString), _variable);
  return variable;
};

var _default = newVariable;
exports.default = _default;
//# sourceMappingURL=newVariable.js.map