"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _append = _interopRequireDefault(require("./append"));

var _getPath = _interopRequireDefault(require("./getPath"));

var _hasPath = _interopRequireDefault(require("./hasPath"));

var _isObject = _interopRequireDefault(require("./isObject"));

var _updateProperty = _interopRequireDefault(require("./updateProperty"));

var _walkReduceDepthFirst = _interopRequireDefault(require("./walkReduceDepthFirst"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createDiff = function createDiff(current, next) {
  var diff = {
    assocs: [],
    dissocs: []
  };
  diff = (0, _walkReduceDepthFirst.default)(function (accum, value, path) {
    if (!(0, _isObject.default)(value)) {
      var currentValue = (0, _getPath.default)(path, current);

      if (currentValue !== value) {
        return (0, _updateProperty.default)('assocs', (0, _append.default)({
          path: path,
          value: value
        }), accum);
      }
    }

    return accum;
  }, diff, next);
  return (0, _walkReduceDepthFirst.default)(function (accum, currentValue, path) {
    if (!(0, _isObject.default)(currentValue) && !(0, _hasPath.default)(path, next)) {
      return (0, _updateProperty.default)('dissocs', (0, _append.default)({
        path: path
      }), accum);
    }

    return accum;
  }, diff, current);
};

var _default = createDiff;
exports.default = _default;
//# sourceMappingURL=createDiff.js.map